<?php
//!!!!!!!  social_sentiment  !!!!!!!!!!!!!!!!!
//
include_once("social_sentiment_common.php");
global $wpdb, $social_sentimentConfigTable;
$status = $daysLeft = $goesLeftToday = '';
//
$device = social_sentiment_getDevice();
$ua=social_sentiment_getBrowser();
$browserName = $ua['name'];
$browserVersion = $ua['version'];
$platform = $ua['platform'];
$dev = $platform.$device;
//
$reload = 'no';
if($device == "mobile" && $platform == "android" && !isset($_POST['reload'])){
	//need to reload to force correct device width
	$reload = 'yes';
}


$config = $wpdb->get_results("SELECT * from `$social_sentimentConfigTable`");
if(count($config) > 0){
	$domain = $config[0]->domain;
	$key = $config[0]->api_key;
	$status = $config[0]->status;
	$maxCharts = $config[0]->max_charts;
	$goesLeftToday = $config[0]->goes_left_today;
	$itemNumber = $config[0]->item_number;
	$positiveColour = $config[0]->positive_colour;
	$neutralColour = $config[0]->neutral_colour;
	$negativeColour = $config[0]->negative_colour;
	$coloursString = '"'.$positiveColour.'","'.$neutralColour.'","'.$negativeColour.'"';
}

?>
<script>
var items = [];
var s_n = s_p = s_nn = N = 0;
var max_charts = <?php echo $maxCharts;?>;
jQuery(document).ready(function($){
	displaySavedCharts();
	jQuery.ajax({
		url:"<?php echo admin_url('admin-ajax.php'); ?>",
		type: "POST",
		dataType:"json",
		data:({
			action:"social_sentiment_ajax_initialize"
		}),
		success: function(r){
			if(r['status'] == 'success'){
				jQuery('#goes_left').html(r['goes_left']);
				jQuery('#service_status').html(r['plan_name']);
				jQuery('#days_left').html(r['days_left']);
				max_charts = r['max_charts'];
				console.log('days left: '+r['days_left']);
				if(jQuery('#days_left').html() > low_days || jQuery('#days_left').html() < 1){
					jQuery('#buy_reminder_window').hide();
				}else
				{
					jQuery('#buy_reminder_window').show();
				}
			}else
			{
				console.log('goes update failed, status: '+r['status']+' ('+r['message']+')');
			}
			
		},
		error: function(jqXHR,error, errorThrown,data) {  
			//console.log(jqXHR.responseText + ' '+error+' '+errorThrown+' '+data);
			jQuery('#progress_table').hide();
			console.log(this['url']);
			var text;
			if(jqXHR.responseText){
				text = jqXHR.responseText;
			}else
			{
				if(error){
					text = error;
				}else
				if(errorThrown){
					text = errorThrown;
				}
			}
			console.log(text);
		},
		timeout: 6000
	});
});
function getSentiment(){
	//first delete any previous results
	jQuery('#progress_table').show();
	jQuery('#spinner_text').html('measuring sentiment');
	jQuery('#find_status_box').html('');
	jQuery('.item_box_style').remove();
	jQuery('.result_row').remove();
	jQuery('#save_row').hide();
	//
	var search_term = jQuery('#search_term').val();
	var type = jQuery('#type').val();
	var item_number = jQuery('#item_number').val() ? jQuery('#item_number').val() : <?php echo $itemNumber;?>;
	if(search_term == ''){
		dialog('','Please supply a search term');
	}
	
	jQuery.ajax({
		url:"<?php echo admin_url('admin-ajax.php'); ?>",
		type: "POST",
		dataType:"json",
		data:({
			action:"social_sentiment_get_sentiment",
			search_term: search_term,
			type: type,
			number: item_number
		}),
		success: function(r){
			if(r['status'] == 'success'){
				jQuery('#progress_bar').width(perm_offset+'%');
				//call checker using returned permutations
				if(r['items']){
					console.log('number of items: '+r['items'].length);
					items = r['items'];
					max_charts = r['max_charts'];
					jQuery('#goes_left').html(r['goes_left']);
					jQuery('#service_status').html(r['plan_name']);
					jQuery('#days_left').html(r['days_left']);
					if(jQuery('#days_left').html() > low_days || jQuery('#days_left').html() < 1){
						jQuery('#buy_reminder_window').hide();
					}else
					{
						jQuery('#buy_reminder_window').show();
					}
					//list.unshift('');
					var N = items.length;
					if(N > 0){
						jQuery('#progress_table').hide();
						jQuery('#save_row').show();
						addResultRow(0);
						createChart(r['search_tag']+r['search_term'],'piechart_0');
						displayList('item_list_0');
					}else
					{
						jQuery('#spinner').hide();
						jQuery('#spinner_text').html('Sorry, no items found');
	
					}
				}else
				{
					jQuery('#spinner').hide();
					jQuery('#spinner_text').html('Sorry, no items found');
				}
			}else
			{
				jQuery('#progress_table').hide();
				jQuery('#find_status_box').show();
				jQuery('#find_status_box').html(r['message']);
				console.log('status: '+r['status']+' ('+r['message']+')');
			}
			
		},
		error: function(jqXHR,error, errorThrown,data) {  
			//console.log(jqXHR.responseText + ' '+error+' '+errorThrown+' '+data);
			jQuery('#progress_table').hide();
			console.log(this['url']);
			var text;
			if(jqXHR.responseText){
				text = jqXHR.responseText;
			}else
			{
				if(error){
					text = error;
				}else
				if(errorThrown){
					text = errorThrown;
				}
			}
			console.log(text);
		},
		timeout: 180000
	});
}
//
function saveSentiment(){
	//first delete any previous results

	console.log('N: '+N+' max_charts: '+max_charts);
	if(N >= max_charts){
		dialog('','','Sorry, you cannot save another chart on this plan. Please delete a chart or upgrade.');
		jQuery('#save_row').hide();
		displaySavedCharts();
		return;	
	}	
	jQuery('.item_box_style').remove();
	jQuery('#piechart_0').html('');
	var search_term = jQuery('#search_term').val();
	var type = jQuery('#type').val();
	var item_number = jQuery('#item_number').val() ? jQuery('#item_number').val() : <?php echo $itemNumber;?>;
	if(search_term == ''){
		dialog('','Search term missing');
		return;
	}
	/*display = 'no';
	if(jQuery('#display').is(':checked')){
		display = 'yes';
	}*/
	jQuery.ajax({
		url:"<?php echo admin_url('admin-ajax.php'); ?>",
		type: "POST",
		dataType:"json",
		data:({
			action:"social_sentiment_save_sentiment",
			search_term: search_term,
			type: type,
			number: item_number,
			/*display_items: display,*/
			items: items
		}),
		success: function(r){
			jQuery('#save_row').hide();
			if(r['status'] == 'success'){
				displaySavedCharts();
			}else
			{
				console.log('status: '+r['status']+' ('+r['message']+')');
			}
			
		},
		error: function(jqXHR,error, errorThrown,data) {  
			console.log(this['url']);
			var text;
			if(jqXHR.responseText){
				text = jqXHR.responseText;
			}else
			{
				if(error){
					text = error;
				}else
				if(errorThrown){
					text = errorThrown;
				}
			}
			console.log(text);
		},
		timeout: 60000
	});
}
//
function displaySavedCharts(){
	//first delete any previous results
	jQuery('.result_row').remove();
	//
	
	jQuery.ajax({
		url:"<?php echo admin_url('admin-ajax.php'); ?>",
		type: "POST",
		dataType:"json",
		data:({
			action:"social_sentiment_get_saved_sentiment"
		}),
		success: function(r){
			if(r['status'] == 'success'){
				if(r['saved_items']){
					var saved_items = r['saved_items'];
					var search_tag = search_term = search_id = shortcode = chart_id = detail_id = '';
					//list.unshift('');
					N = saved_items.length;
					console.log('N: '+N);
					if(N > 0){
		
						for(var c=0;c<N;c++){
							items = saved_items[c]['items'];
							search_tag = saved_items[c]['type'];
							search_term = saved_items[c]['term'];
							search_id = saved_items[c]['search_id'];
							shortcode = '[social_sentiment id='+search_id+' width=200 position=centre]';
							chart_id = 'piechart_'+c;
							detail_id = 'item_list_'+c;
							//add new row to results table
							addResultRow(c);			
							createChart(search_tag+search_term,chart_id);
							jQuery('#item_list_'+c).html('<br>shortcode '+shortcode+'<br><br><div class="large_button chart_delete_button" id="delete_chart_'+search_id+'">delete</div>');
						}
					}else
					{
						jQuery('#spinner_text').html('Sorry, no items found');
	
					}
				}else
				{
					N = 0;
					console.log('N: '+N);
				}
			}else
			{
				jQuery('#progress_table').hide();
				jQuery('#find_status_box').show();
				jQuery('#find_status_box').html(r['message']);
				console.log('status: '+r['status']+' ('+r['message']+')');
			}
			
		},
		error: function(jqXHR,error, errorThrown,data) {  
			//console.log(jqXHR.responseText + ' '+error+' '+errorThrown+' '+data);
			jQuery('#progress_table').hide();
			console.log(this['url']);
			var text;
			if(jqXHR.responseText){
				text = jqXHR.responseText;
			}else
			{
				if(error){
					text = error;
				}else
				if(errorThrown){
					text = errorThrown;
				}
			}
			console.log(text);
		},
		timeout: 60000
	});
}
//
function addResultRow(c){
	var res_table = document.getElementById('results_table');
	var chart_id = 'piechart_'+c;
	var detail_id = 'item_list_'+c;
	row = document.createElement('div');
	row.className = 'row result_row';
	chart_span = document.createElement('span');
	chart_span.className = 'chart_cell';
	chart_span.id = chart_id;
	row.appendChild(chart_span);
	detail_span = document.createElement('span');
	detail_span.className = 'items_cell';
	detail_span.id = detail_id;
	row.appendChild(detail_span);
	res_table.appendChild(row);
}
//
google.load("visualization", "1", {packages:["corechart"]});
function createChart(search_term,id) {
	//
	s_n = s_p = s_nn = 0;
	for(var c=0;c<items.length;c++){
		if(items[c]['score'] > 0){
			s_p++;
		}else
		if(items[c]['score'] < 0){
			s_nn++;
		}else
		{
			s_n++;	
		}
	}

      //google.setOnLoadCallback(drawChart);

        var data = google.visualization.arrayToDataTable([
          ['Sentiment', 'Percent'],
          ['positive', s_p],
          ['Neutral', s_n],
          ['Negative', s_nn]
        ]);

        var options = {
          title: 'social media sentiment for \n '+search_term,
		  titleTextStyle: {fontSize: 12},
		  colors: [<?php echo $coloursString;?>]
        };

        var chart = new google.visualization.PieChart(document.getElementById(id));

        chart.draw(data, options);
}
function displayList(id){
	var list_box = document.getElementById(id);
	for(var c=0;c<items.length;c++){
		var item_box = document.createElement('div');
		if(c % 2 == 0){
			item_box.className = 'item_box_style white_back';
		}else
		{
			item_box.className = 'item_box_style grey_back';
		}
		var date_box = document.createElement('span');
		date_box.className = 'date_box_style';
		date_box.innerHTML = items[c]['date']+' ';
		var name_box = document.createElement('span');
		name_box.className = 'name_box_style';
		name_box.innerHTML = 'By '+items[c]['name']+' on ';
		var text_box = document.createElement('div');
		text_box.className = 'text_box_style';
		text_box.innerHTML = items[c]['text'];
		item_box.appendChild(name_box);
		item_box.appendChild(date_box);
		item_box.appendChild(text_box);
		list_box.appendChild(item_box);
	}
}
jQuery(document).on('click', '.chart_delete_button', function(){
	var id = this.id;
	dialog('doDelete',id,'Are you sure you want to delete this chart ?');
});
	
function doDelete(id){
	console.log('deleting chart '+id);	
	jQuery.ajax({
		url:"<?php echo admin_url('admin-ajax.php'); ?>",
		type: "POST",
		dataType:"json",
		data:({
			action:"social_sentiment_delete_sentiment",
			id: id
		}),
		success: function(r){
			if(r['status'] == 'success'){
				console.log(r['message']);
				displaySavedCharts();		
			}else
			{
				jQuery('#progress_table').hide();
				jQuery('#find_status_box').show();
				jQuery('#find_status_box').html(r['message']);
				console.log('status: '+r['status']+' ('+r['message']+')');
			}
			
		},
		error: function(jqXHR,error, errorThrown,data) {  
			//console.log(jqXHR.responseText + ' '+error+' '+errorThrown+' '+data);
			console.log(this['url']);
			var text;
			if(jqXHR.responseText){
				text = jqXHR.responseText;
			}else
			{
				if(error){
					text = error;
				}else
				if(errorThrown){
					text = errorThrown;
				}
			}
			console.log(text);
		},
		timeout: 60000
	});
}
</script>
	<div id="outer_container">
		<div id="container" class="centre">			
			<div id="header">				
				<div id="logo">
					<div id="logo_title">social sentiment</div>
					<div id="logo_sub_title">a social media sentiment plugin by scideas software</div>
				</div>
				<div id="status_bar">
					<div class="row">
						<span class="cell align_base">Status:</span><span class="cell black align_base" id="service_status"><?php echo $status;?></span>
						<span class="cell align_base">Searches left today:</span><span class="cell black align_base" id="goes_left"><?php echo $goesLeftToday;?></span>
						<span class="cell align_base">Days left:</span><span class="cell black align_base" id="days_left"><?php echo $daysLeft;?></span>
						<a href="http://services.scideas.net/sentiment/buy_credits.php?host=<?php echo $domain;?>&key=<?php echo $key;?>" target="_blank"><span class="cell align_base"><div class="buy_button">Subscribe</div></span></a>
					</div>
				</div>
		
			</div>
			<div id="help_box">
				<div id="title_text">How to use <font class="italic">social sentiment</font> plugin</div>
				<div class="help_section_title">The Search Tab</div>
					<ul>
						<li>Use any search term and optionally choose a # or @ tag</li>
						<li>Choose how many recent tweets to search for</li>
						<li>Click on the <font class="italic">Get Sentiment</font> button and wait for the search to complete</li>
						<li>When the search is complete and the pie chart is displayed you may save the chart if your plan allows it</li>
						<li>If you have reached your maximum number of saved charts you may delete one in order to save a new one</li>
						<li>After saving, your saved charts will be displayed on the search page</li>
						<li>There is a daily limit on searches, the value depends on your plan</li>
					</ul>
						
		
				<div class="help_section_title">Displaying the charts in your WP pages</div>
					<ul>
						<li>Alongside each saved chart on the search page you will see an example shortcode</li>
						<li>To display the chart on a page use the shortcode id and the following parameters</li>
							<ol>
								<li><font class="bold">width</font> - this is the displayed width in pixels (height will be the same)</li>
								<li><font class="bold">position</font> - this may be left, centre or right</li>
							</ol>

					</ul>
					
				<div class="help_section_title">The Configuration Tab</div>
					<ul>
						<li>You can set the default number of tweets to search up to a maximum depending on your plan</li>
						<li>You can set the colour used for each sentiment - this will be the same for all pie charts</li>
					</ul>
				
				<div class="help_section_title">Sidebar widget</div>
					<ul>
						<li>Drag the Social Sentiment widget from the Available Widgets box to the Widgets Area box in your WP admin Widgets page</li>
						<li>Use the charts shortcode id as the widget title and save it</li>
					</ul>
				<div class="help_section_title">Subscription plans</div>
					<ul>
						<li>When you install <font class="italic">social sentiment</font> you have a trial period in which you may save and display one chart</li>
						<li>Your plan and the days remaining in your plan will be displayed at the top of each <font class="italic">social sentiment</font>admin page</li>
						<li>When your trial ends you will be downgraded to the free service, allowing only one saved chart which will not be updated automatically</li>
						<li>Use the <font class="italic">Subscribe</font> buttons to upgrade your plan allowing more charts to be saved and more searches per day</li>
						<li>Your plan will allow you a maximum number of saved charts - to save a new one when you have reached your limit, delete an old one first</li>
						<li><font class="italic">social sentiment</font> works via a web service and your plan will only be valid for the WP domain where it is installed</li>
					</ul>
				</div>
						

			</div>

					
					
			
			<div id="footer">
				<div class="centre" id="footer_table">
					<div class="row">
						<span class="cell"><font class="italic">social sentiment</font> by <a href="http://new.scideas.net" target="_blank">scideas software</a></span>
						<!--<span class="cell clickable" onclick="openBox('contact');">contact</span>-->
					</div>
				</div>
			</div>
			
			
			
		
			
					
		</div><!--end of container-->
		
		
		
	</div><!--end of outer container-->
	
	
	

	<form id="logoutForm" method="post"><input type="hidden" id="logout" name="logout" value="yes"/></form>
	<form id="reloadForm" method="post"><input type="hidden" id="reload" name="reload" value="<?php echo $reload;?>"/></form>
</body>

</html>